#include <bits/stdc++.h>
using namespace std;

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, q; cin >> n >> q;
    vector<int64_t> d (n);
    vector<int> p (n);
    for(int i=0; i<n; i++){
        int direkt, otrov; cin >> direkt >> otrov;
        d[i] = direkt;
        p[i] = otrov;
        if(i!=0) d[i] += d[i-1];
    }

    while(q--){
        int helt; cin >> helt;
        int id = upper_bound(d.begin(), d.end(), helt) - d.begin();
        if(id == 0){
            cout << "-1\n";
            continue;
        }
        if(d[id-1] == helt){
            cout << id << '\n';
        }
        else{
            cout << id+1 << '\n';
        }

    }



}